<template>
    <div class="row" v-if="addMode">
        <div class="col-auto">
            <label for="numberInput" class="col-form-label">Номер</label>
            <input class="form-control" id="numberInput" v-model="newCode.number">
        </div>
        <div class="col-auto">
            <label for="nameInput" class="col-form-label">Название</label>
            <input class="form-control" id="nameInput" v-model="newCode.name">
        </div>
        <div class="col-auto mt-auto">
            <button type="button" class="btn btn-sm btn-default" @click="addCode">
                Добавить
                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-plus-square" viewBox="0 0 16 16">
                    <path fill-rule="evenodd" d="M14 1H2a1 1 0 0 0-1 1v12a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1V2a1 1 0 0 0-1-1zM2 0a2 2 0 0 0-2 2v12a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V2a2 2 0 0 0-2-2H2z"/>
                    <path fill-rule="evenodd" d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4z"/>
                </svg>
            </button>
            <button type="button" class="btn btn-sm btn-default" @click="deactivateAddMode">
                <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-slash-circle text-danger" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                    <path fill-rule="evenodd" d="M8 15A7 7 0 1 0 8 1a7 7 0 0 0 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z"/>
                    <path fill-rule="evenodd" d="M11.354 4.646a.5.5 0 0 1 0 .708l-6 6a.5.5 0 0 1-.708-.708l6-6a.5.5 0 0 1 .708 0z"/>
                </svg>
            </button>
        </div>
    </div>
    <div class="row" v-else>
        <div class="col-12">
            <button type="button" class="btn btn-sm btn-default" :disabled="!isEditPossible" @click="activateAddMode">
                Добавить бюджетный код
                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-plus-square" viewBox="0 0 16 16">
                    <path fill-rule="evenodd" d="M14 1H2a1 1 0 0 0-1 1v12a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1V2a1 1 0 0 0-1-1zM2 0a2 2 0 0 0-2 2v12a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V2a2 2 0 0 0-2-2H2z"/>
                    <path fill-rule="evenodd" d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4z"/>
                </svg>
        </button>
        </div>
    </div>
</template>

<script>
    import { BudgetCodesService } from '../../services/budgetCodesService'
    import { defaultHandleErrorFunction } from '@/services/http-common'

    export default {
        name: 'BudgetCodeAdd',
        props: {
            municipalityId: Number,
            isEditPossible: Boolean,
            codeType: String
        },
        emits: ['update:isEditPossible', 'codeAdded'],
        data() {
            return {
                addMode: false,
                newCode: {
                    number:"",
                    name:""
                } 
            }
        },
        methods: {
            activateAddMode() {
                this.newCode = {
                    code:"",
                    name:""
                };
                this.changeAddMode(true);
            },
            addCode() {
                const budgetCodesService = new BudgetCodesService();
                budgetCodesService
                    .create({
                        MunicipalityId: this.municipalityId,
                        Number: this.newCode.number,
                        Name: this.newCode.name,
                        Type: this.codeType,
                        IsActive: true
                    })
                    .then(response => this.$emit('codeAdded'))
                    .catch(defaultHandleErrorFunction);
                this.deactivateAddMode();
            },
            deactivateAddMode() {
                this.changeAddMode(false);
            },
            changeAddMode(isAdding) {
                this.addMode = isAdding;
                this.$emit('update:isEditPossible', !isAdding);
            }
        }
    };
</script>